package com.gxwebsoft.oa.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.gxwebsoft.oa.mapper.OaTaskRecordMapper;
import com.gxwebsoft.oa.service.OaTaskRecordService;
import com.gxwebsoft.oa.entity.OaTaskRecord;
import com.gxwebsoft.oa.param.OaTaskRecordParam;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.PageResult;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 工单回复记录表Service实现
 *
 * @author 科技小王子
 * @since 2024-09-10 20:57:42
 */
@Service
public class OaTaskRecordServiceImpl extends ServiceImpl<OaTaskRecordMapper, OaTaskRecord> implements OaTaskRecordService {

    @Override
    public PageResult<OaTaskRecord> pageRel(OaTaskRecordParam param) {
        PageParam<OaTaskRecord, OaTaskRecordParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        List<OaTaskRecord> list = baseMapper.selectPageRel(page, param);
        return new PageResult<>(list, page.getTotal());
    }

    @Override
    public List<OaTaskRecord> listRel(OaTaskRecordParam param) {
        List<OaTaskRecord> list = baseMapper.selectListRel(param);
        // 排序
        PageParam<OaTaskRecord, OaTaskRecordParam> page = new PageParam<>();
        page.setDefaultOrder("create_time desc");
        return page.sortRecords(list);
    }

    @Override
    public OaTaskRecord getByIdRel(Integer taskRecordId) {
        OaTaskRecordParam param = new OaTaskRecordParam();
        param.setTaskRecordId(taskRecordId);
        return param.getOne(baseMapper.selectListRel(param));
    }

}
